package io.gitlab.jfronny.yescheat;

import io.gitlab.jfronny.yescheat.mixin.*;
import io.gitlab.jfronny.yescheat.mixin.UncapEnchants;
import io.gitlab.jfronny.yescheat.mixin.UnlockMendingInfinity;
import org.objectweb.asm.tree.ClassNode;
import org.spongepowered.asm.mixin.extensibility.IMixinConfigPlugin;
import org.spongepowered.asm.mixin.extensibility.IMixinInfo;

import java.util.*;

public class Plugin implements IMixinConfigPlugin {
    @Override
    public void onLoad(String mixinPackage) {
    }

    @Override
    public String getRefMapperConfig() {
        return null;
    }

    @SuppressWarnings("ReferenceToMixin")
    @Override
    public boolean shouldApplyMixin(String targetClassName, String mixinClassName) {
        if (Objects.equals(mixinClassName, UnblockChests.class.getName()))
            return Cfg.unblockChests;
        else if (Objects.equals(mixinClassName, UncapEnchants.class.getName()))
            return Cfg.uncapEnchants;
        else if (Objects.equals(mixinClassName, IgnoreEula.class.getName()))
            return true;
        else if (Objects.equals(mixinClassName, DistantContainers3x3.class.getName())
                || Objects.equals(mixinClassName, DistantContainerXx9.class.getName()))
            return Cfg.distantContainers;
        else if (Objects.equals(mixinClassName, UnlockMendingInfinity.class.getName()))
            return Cfg.unlockMending;
        else if (Objects.equals(mixinClassName, DistantBreaking.class.getName()))
            return Cfg.distantBreaking;
        else if (Objects.equals(mixinClassName, RemoveRubberbanding.class.getName()))
            return Cfg.antiRubberband;
        else if (Objects.equals(mixinClassName, VillagersFollowEmeralds.class.getName()))
            return Cfg.villagersFollowEmeralds;
        else
            throw new IllegalStateException("Unrecognized mixin: " + mixinClassName + "! This should never happen");
    }

    @Override
    public void acceptTargets(Set<String> myTargets, Set<String> otherTargets) {
    }

    @Override
    public List<String> getMixins() {
        return null;
    }

    @Override
    public void preApply(String targetClassName, ClassNode targetClass, String mixinClassName, IMixinInfo mixinInfo) {
    }

    @Override
    public void postApply(String targetClassName, ClassNode targetClass, String mixinClassName, IMixinInfo mixinInfo) {
    }
}
